
object Substitution1 {

  def create (s:Subscriber[String]):Subscriber[String] = new SubstImpl(s)

  private class SubstImpl (s:Subscriber[String]) extends Subscriber[String] {

    private var map = SubstitutionMap.empty()

    def notify (data:String):Unit = 
      if (data.startsWith("$ ")) {
	val res = data.split(" +",4)
	if (res.size >= 4 && res(2)=="=")
	  map = map.add(res(1),res(3))
      }	else 
	s.notify(map.subst(data))
  }
}

